#ifndef QCALC_OUTPUT_ITEM_H
#define QCALC_OUTPUT_ITEM_H

#include "qcalcCommon.h"
#include "qcalcCalcItem.h"
#include "qcalcSlots.h"
// #include "qcalcTimeSlots.h"

// virtual output item. Only one input slot
class VOutputItem: public VCalcItem
{
	public:
		VOutputItem();
		
		virtual ~VOutputItem();
		
		virtual void reevaluateOutSlots();
		
		bool computeValue();
		
		virtual OutputItem* getGUI();
		
		void removeGUI();
		
		inline void setOutputName(const QString& name){this->outputName=name;}

        virtual QDomElement toXMLElement(QDomDocument&) const;

        virtual void fromXMLElement(QDomElement& el, QGraphicsScene* scene);
        
		
		static int counter;
		int output_id;
		inline virtual bool hasGui(){return gui!=NULL;}
		QString outputName;

	protected:
		OutputItem* gui;
		
};


class OutputItem: public CalcItem
{
	Q_OBJECT
	public:
		OutputItem(VOutputItem* parentItem, VInSlot* input, QGraphicsItem* parent=NULL);
		
		virtual ~OutputItem();
		
		virtual void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget=NULL);
		
		inline virtual int type() const { return Type;}
		enum { Type = TYPE_OUTPUTITEM };
		VOutputItem* parentItem;

        virtual QDomElement toXMLElement(QDomDocument& doc) const;

        virtual void fromXMLElement(QDomElement& el);
        
		// updates the inbound and outbound connectors' graphics
		virtual void updateConnectorsPositions();
		
		
		inline void setOutputName(const QString& name){edit->setText(name);}
		virtual int page(){return parentItem->page;}
		void setValue(const QString& text);

	protected:
		QLineEdit* edit;
		virtual QVariant itemChange(GraphicsItemChange change, const QVariant& value);
		
	public slots:
		void setValue();
};



#endif
