/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "DvObj.h"
#include "qplug_if.h"

extern "C" QplugReturnStatus DvQarSUBTRACT(vector <DvObject_var>&, vector <DvObject_var>&);

QplugReturnStatus DvQarSUBTRACT(vector <DvObject_var>& inputs, vector <DvObject_var>& outputs)
{
	QplugReturnStatus	status;

	DvObject_var in1_ptr;
	DvObject_var in2_ptr;
	DvObject_var out_ptr;


	DvString out_name;

	status = QPLUG_SUCCESS;

	//	Unpack the input data objects

	in1_ptr = inputs[0];
	in2_ptr = inputs[1];


	// Get name of output object

 	out_name = GetSlotText(0);
 	if ( out_name.empty() ) {
    	out_name = "Sum";
    	SetSlotText(0, out_name.c_str());
 	}


	// do arithmetic ...


	if(in1_ptr->seqSize() > 1){
		out_ptr = in1_ptr - in2_ptr;
	}
	else{
		// val2 may be a sequence
		out_ptr = in2_ptr->chgSign();
		out_ptr += in1_ptr;
	}

	if ( out_ptr.is_nil() ) {
    	QplugAppendTextDisplay ("Arithmetic>> Subtract not yet supported between these types\n");
    	return QPLUG_FAILURE; 
	}
 
	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );

	//	..add  the output series to the list

	outputs.push_back(out_ptr);

	QplugAppendTextDisplay ("Subtract: Done\n");
  
	return status;

}

