#include "qcalcEvaluator.h"


void QEvaluatorPiecewise::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	result = val1->multElements(val2);
	
	
	if ( result.is_nil() )
	{
		message="Arithmetic>> Element multiply is not supported between these input types" ;
		ok=false;
		return;
	}
	
	out[0]->setValue(result, true);
	
}

// --------------------------------------------------------------------

void QEvaluatorPwDiv::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	result = val1->divideElements(val2);

	if ( result.is_nil() )
	{
		message="Arithmetic>> Element divide is not supported between these input types" ;
		ok=false;
		return;
	}
	
	out[0]->setValue(result, true);
	
}
