#include "qcalcEvaluator.h"


void QEvaluatorRemainder::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	QString rqstrErrorMsg;
	DvObject_var qRemainder_out = new DvObject();
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok) return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	if(val1->isThreeVector())
	{
		message=QString("Operation is not meaningful for vector objects");
		ok=false;
		return;
	}
	
	if(val2->totalSize() == 1) qRemainder_out = val1->remainder(val2->asDouble(0));
	else qRemainder_out = val1->remainder(val2);

	
	out[0]->setValue(qRemainder_out, true);
}
