#include "GuiConfig.h"

GuiConfig::GuiConfig()
{
	QBoxLayout * v_layout=new QBoxLayout(QBoxLayout::TopToBottom, this);

	v_layout->setSpacing(QSAS_profiles->current()->GUImargins);
	v_layout->setMargin(QSAS_profiles->current()->GUImargins);
	
	QBoxLayout * h_layout_1=new QBoxLayout(QBoxLayout::LeftToRight);
	QBoxLayout * h_layout_2=new QBoxLayout(QBoxLayout::LeftToRight);
	QBoxLayout * h_layout_3=new QBoxLayout(QBoxLayout::LeftToRight);
	QBoxLayout * h_layout_4=new QBoxLayout(QBoxLayout::LeftToRight);
	QBoxLayout * h_layout_5=new QBoxLayout(QBoxLayout::LeftToRight);
	QBoxLayout * h_layout_6=new QBoxLayout(QBoxLayout::LeftToRight);
	QBoxLayout * h_layout_7=new QBoxLayout(QBoxLayout::LeftToRight);

	h_layout_1->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_1->setMargin(QSAS_profiles->current()->GUImargins);
	
	h_layout_2->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_2->setMargin(QSAS_profiles->current()->GUImargins);
	
	h_layout_3->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_3->setMargin(QSAS_profiles->current()->GUImargins);
	
	h_layout_4->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_4->setMargin(QSAS_profiles->current()->GUImargins);
	
	h_layout_5->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_5->setMargin(QSAS_profiles->current()->GUImargins);
	
	h_layout_6->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_6->setMargin(QSAS_profiles->current()->GUImargins);
	
	h_layout_7->setSpacing(QSAS_profiles->current()->GUImargins);
	h_layout_7->setMargin(QSAS_profiles->current()->GUImargins);
	
	QLabel * tempLabel=new QLabel("Default main window height (in characters)*: ", this);
	tempLabel->setWordWrap(true);

	h_layout_1->addWidget(tempLabel);
	
	heightLine=new QLineEdit(this);
	heightLine->setValidator(new QIntValidator(10, 100, heightLine));
	h_layout_1->addWidget(heightLine);
	
	tempLabel=new QLabel("Default size for the plot interface *", this);
	tempLabel->setWordWrap(true);

	h_layout_2->addWidget(tempLabel);
	
	QpuiSizeLine=new QLineEdit(this);
	QpuiSizeLine->setEnabled(false);
	h_layout_2->addWidget(QpuiSizeLine);
	
	QpuiSizeButton=new QPushButton("Get current size", this);
	h_layout_2->addWidget(QpuiSizeButton);
	connect(QpuiSizeButton, SIGNAL(clicked()), this, SLOT(getQpuiSize()));
	
	tempLabel=new QLabel("Font size in pixels: ", this);
	tempLabel->setWordWrap(true);

	h_layout_3->addWidget(tempLabel, 0, Qt::AlignRight);
	
	fontSizeBox=new QSpinBox(this);

	fontSizeBox->setMinimum(4);
	fontSizeBox->setMaximum(20);

	fontSizeBox->setSpecialValueText("Default");
	h_layout_3->addWidget(fontSizeBox, 0, Qt::AlignLeft);


	toolbarBox=new QCheckBox("Show Toolbars at Startup* ", 0);
	h_layout_3->addWidget(toolbarBox, 0, Qt::AlignRight);

       	
	tempLabel=new QLabel("Compact GUI* ", this);

	h_layout_4->addWidget(tempLabel, 0, Qt::AlignRight);

	compactUIBox=new QComboBox;
	compactUIBox->addItem("Off");
	compactUIBox->addItem("On");
	h_layout_4->addWidget(compactUIBox, 0, Qt::AlignLeft);
	
    
	tempLabel=new QLabel("WL Slot Pulldown* ", this);

	h_layout_4->addWidget(tempLabel, 0, Qt::AlignRight);

	slotLRBox=new QComboBox;
	slotLRBox->addItem("Right");
	slotLRBox->addItem("Left");
	h_layout_4->addWidget(slotLRBox, 0, Qt::AlignLeft);
	
 	
	tempLabel=new QLabel("Interactive Interval Editor Button ", this);
	tempLabel->setWordWrap(true);

	h_layout_5->addWidget(tempLabel);

	timeIntervalButtonBox=new QComboBox;
	timeIntervalButtonBox->addItem("Left or Right click");
	timeIntervalButtonBox->addItem("Right click only");
	h_layout_5->addWidget(timeIntervalButtonBox);
	
	tempLabel=new QLabel("Time Fields, decimal places for Seconds: ", this);
#if QT_VERSION >= 0x040000
	tempLabel->setWordWrap(true);
#endif
	h_layout_6->addWidget(tempLabel);
	
	secDecimalBox=new QSpinBox(this);
	secDecimalBox->setMinimum(0);
	secDecimalBox->setMaximum(9);
	secDecimalBox->setToolTip("maximum significant digits of picoseconds is possible with CDF Epoch16");
	h_layout_6->addWidget(secDecimalBox);
	
	tempLabel=new QLabel("Start using Gregorian Calendar from: ", this);
	h_layout_7->addWidget(tempLabel);
	
	gregorian_start_fld = new QLineEdit(this);
	gregorian_start_fld->setFixedWidth(150);
	h_layout_7->addWidget(gregorian_start_fld, 0, Qt::AlignLeft);

	v_layout->addLayout(h_layout_1);
	v_layout->addLayout(h_layout_2);
	v_layout->addLayout(h_layout_3);
	v_layout->addLayout(h_layout_4);
	v_layout->addLayout(h_layout_5);
	v_layout->addLayout(h_layout_6);
	v_layout->addLayout(h_layout_7);
	QPUI_widget=NULL;
}

void GuiConfig::getQpuiSize()
{
	if(QPUI_widget!=NULL)
	{
		QSize size=QPUI_widget->size();
		qpuiHeight=size.height();
		qpuiWidth=size.width();
		QpuiSizeLine->setText(QString("%1 x %2").arg(qpuiWidth).arg(qpuiHeight));
	}
}

void GuiConfig::updateProfile(QProfile* prof)
{
	prof->Height=heightLine->text().toInt();
	prof->QpuiHeight=qpuiHeight;
	prof->QpuiWidth=qpuiWidth;
	prof->fontSize=fontSizeBox->value();
	prof->secDecimal=secDecimalBox->value();
	if(prof->fontSize<5) prof->fontSize=0;
	prof->gregorian_start = gregorian_start_fld->text().toLatin1().data();
    prof->ShowToolbar = toolbarBox->isChecked();
	
	switch(compactUIBox->currentIndex())
	{
		case 1:
			prof->GUImargins=1;
			break;
		case 0:
		default:
			prof->GUImargins=4;
			break;
	}
	
	switch(slotLRBox->currentIndex())
	{
		case 1:
			prof->slotLR=1;
			break;
		case 0:
		default:
			prof->slotLR=0;
			break;
	}
	
	switch(timeIntervalButtonBox->currentIndex())
	{
		case 1:
			prof->timeIntervalButton=1;
			break;
		case 0:
		default:
			prof->timeIntervalButton=0;
			break;
	}	
}

void GuiConfig::setSelectedProfile(QProfile * p)
{
	heightLine->setText(QString().setNum(p->Height));
	qpuiHeight=p->QpuiHeight;
	qpuiWidth=p->QpuiWidth;
	QpuiSizeLine->setText(QString("%1 x %2").arg(qpuiWidth).arg(qpuiHeight));
	if(p->fontSize<5)
	{
		fontSizeBox->setValue(4);
	}
	else
	{
		fontSizeBox->setValue(p->fontSize);
	}
	secDecimalBox->setValue(p->secDecimal);
	gregorian_start_fld->setText(p->gregorian_start.toLatin1().data());

    toolbarBox->setChecked(p->ShowToolbar); 
	
	switch(p->GUImargins)
	{
		case 1:
			compactUIBox->setCurrentIndex(1);
			break;
		default:
			compactUIBox->setCurrentIndex(0);
			break;
	}
	switch(p->slotLR)
	{
		case 1:
			compactUIBox->setCurrentIndex(1);
			break;
		default:
			compactUIBox->setCurrentIndex(0);
			break;
	}
	switch(p->timeIntervalButton)
	{
		case 1:
			timeIntervalButtonBox->setCurrentIndex(1);
			break;
		default:
			timeIntervalButtonBox->setCurrentIndex(0);
			break;
	}
}
