#include "PathConfig.h"

PathConfig::PathConfig()
{
	QGridLayout * layout=new QGridLayout(this);
	
	layout->setSpacing(QSAS_profiles->current()->GUImargins);
	layout->setMargin(QSAS_profiles->current()->GUImargins);
	
	QLabel * tempLabel=new QLabel("Save/Restore default path*", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 0, 0);
	
	saveRestoreLine=new QLineEdit(this);
	layout->addWidget(saveRestoreLine, 0, 1);
	
	QPushButton* saveRestoreButton=new QPushButton("Browse", this);
	connect(saveRestoreButton, SIGNAL(clicked()), this, SLOT(saveRestorePressed()));
	layout->addWidget(saveRestoreButton, 0, 2);
	
	tempLabel=new QLabel("User-defined libraries directory*", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 1, 0);
	
	userLine=new QLineEdit(this);
	layout->addWidget(userLine, 1, 1);
	
	QPushButton* userButton=new QPushButton("Browse", this);
	connect(userButton, SIGNAL(clicked()), this, SLOT(userPressed()));
	layout->addWidget(userButton, 1, 2);
	
	tempLabel=new QLabel("Default directory for Database map files*", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 2, 0);
	
	configLine=new QLineEdit(this);
	layout->addWidget(configLine, 2, 1);
	
	QPushButton* configButton=new QPushButton("Browse", this);
	connect(configButton, SIGNAL(clicked()), this, SLOT(configPressed()));
	layout->addWidget(configButton, 2, 2);
	
	tempLabel=new QLabel("Default directory for Data files*", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 3, 0);
	
	dataLine=new QLineEdit(this);
	layout->addWidget(dataLine, 3, 1);
	
	QPushButton* dataButton=new QPushButton("Browse", this);
	connect(dataButton, SIGNAL(clicked()), this, SLOT(dataPressed()));
	layout->addWidget(dataButton, 3, 2);
	
	tempLabel=new QLabel("Filter bank directory for DWT plug-in", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 4, 0);
	
	filterBankLine=new QLineEdit(this);
	layout->addWidget(filterBankLine, 4, 1);
	
	QPushButton* filterBankButton=new QPushButton("Browse", this);
	connect(filterBankButton, SIGNAL(clicked()), this, SLOT(filterBankPressed()));
	layout->addWidget(filterBankButton, 4, 2);
	
	tempLabel=new QLabel("Black boxes directory for calculator", this);

	tempLabel->setWordWrap(true);

	layout->addWidget(tempLabel, 5, 0);
	
	blackBoxLine=new QLineEdit(this);
	layout->addWidget(blackBoxLine, 5, 1);
	
	QPushButton* blackBoxButton=new QPushButton("Browse", this);
	connect(blackBoxButton, SIGNAL(clicked()), this, SLOT(blackBoxPressed()));
	layout->addWidget(blackBoxButton, 5, 2);
}

void PathConfig::updateProfile(QProfile* prof)
{
	prof->SaveRestorePath=saveRestoreLine->text();
	prof->UserLibPath=userLine->text();
	prof->ConfigPath=configLine->text();
	prof->DataPath=dataLine->text();
	prof->FilterBankPath=filterBankLine->text();
	prof->BlackBoxPath=blackBoxLine->text();
	
}

void PathConfig::setSelectedProfile(QProfile* prof)
{
	saveRestoreLine->setText(prof->SaveRestorePath);
	userLine->setText(prof->UserLibPath);
	configLine->setText(prof->ConfigPath);
	dataLine->setText(prof->DataPath);
	filterBankLine->setText(prof->FilterBankPath);
	blackBoxLine->setText(prof->BlackBoxPath);
}

void PathConfig::saveRestorePressed()
{
	QString res=QFileDialog::getExistingDirectory(this, "Select Save/Restore Directory", saveRestoreLine->text(), QFileDialog::ShowDirsOnly );

	if(!res.isEmpty()) saveRestoreLine->setText(res);
}

void PathConfig::userPressed()
{
	QString res=QFileDialog::getExistingDirectory(this, "Select User-Defined Libraries Directory", userLine->text(), QFileDialog::ShowDirsOnly );

	if(!res.isEmpty()) userLine->setText(res);
}

void PathConfig::configPressed()
{
	QString res=QFileDialog::getExistingDirectory(this, "Select DB default Directory", configLine->text(), QFileDialog::ShowDirsOnly );

	if(!res.isEmpty()) configLine->setText(res);
}

void PathConfig::dataPressed()
{
	QString res=QFileDialog::getExistingDirectory(this, "Select DB default Directory", dataLine->text(), QFileDialog::ShowDirsOnly );

	if(!res.isEmpty()) dataLine->setText(res);
}

void PathConfig::filterBankPressed()
{
	QString res=QFileDialog::getExistingDirectory(this, "Select Filter Bank Directory", filterBankLine->text(), QFileDialog::ShowDirsOnly );

	if(!res.isEmpty()) filterBankLine->setText(res);
}

void PathConfig::blackBoxPressed()
{
	QString res=QFileDialog::getExistingDirectory(this, "Select Black Boxes Directory", blackBoxLine->text(), QFileDialog::ShowDirsOnly );

	if(!res.isEmpty()) blackBoxLine->setText(res);
}
