//  qdi.h
//
//  Qsas - Direct Import Header File
//
//  Tony Allen
//  Sept 2002, 2016
//

#ifndef QSAS_DI_H_
#define QSAS_DI_H_

#include <QObject>
#include "qdutil.h"
#include "qslot.h"

#include "qbu.h"
#include "qxml.h"

#include "qie_caa.h"
#include <QListWidget>
#include <QCheckBox>

 

// Direct Access QIE rewrite
// --------------------------------------------------

class DirectAccessWindow : public QMainWindow {

Q_OBJECT

  QStatusBar* _status_bar;
  QMenuBar *_menu_bar;
  
public slots:
  void close();
  int getFileContents(const char *file);
  void setSliders(int nRecs);
  void getData();
  void browseData();
  void clearGattrList();
  void clearVarList();
  void varDoubleClick(QListWidgetItem*);
  void GattrDoubleClick(QListWidgetItem*);
  void setSliderForItem(QListWidgetItem*);
  void launchVersion();
  void launchManDirectImport();
  void launchManual();
  void updateOnSelection(QieVariable *V=0);
  void tRangeToggle();

signals:
  
public:
  DirectAccessWindow( QWidget *parent=0, const char *name=0 );
    
  QStatusBar *msgBar;
  QListWidget* varList;
  QListWidget* GattrList;
  QieData *QieDataCont;		/* qie Contents Structure */
  QString Selected_File_Path;
  QListWidget* activeList;
  DvObject_var  tt;               /* single time tag source for whole file */
  RecordSlider *fromSlider;
  RecordSlider *toSlider;
  QGroupBox *subset_panel;
  QCheckBox *useTcheck;
  
protected:
  void keyPressEvent(QKeyEvent * e );
  QPushButton *getVarBtn;
  QPushButton *browseVarBtn;
  QPushButton *dismissBtn;
  
};
 

 void DaLaunchWindow(QString file, QWidget *parent);

# endif // QSAS_DI_H_
