// floatspinbox.cc
//
// Floating Point Spinner Class for Qt - Implementation  File
//
//


#include "floatspinbox.h"

#include <qspinbox.h>
#include <cmath>
#include <iostream>

/*!
  \class FloatSpinBox floatspinbox.h
  \brief reimplements QSpinBox for float values
*/

FloatSpinBox::FloatSpinBox( QWidget* parent, const char* name )
  : QDoubleSpinBox(parent)// int(-2e10), int(2e10), 10, parent, name ),dec(2)
{
	setDecimals(2);
	setRange(-2.e10, 2.e10);
	setSingleStep(0.5);
	setValue( 0.0 );
	setFocusPolicy(Qt::StrongFocus);
}

FloatSpinBox::FloatSpinBox( float minValue, float maxValue, int decimals, float step, QWidget* parent, const char* name )
  : QDoubleSpinBox(parent)
{
	setDecimals(decimals);
	setRange(minValue, maxValue);
	setSingleStep(step);
	setValue( minValue );
	setFocusPolicy(Qt::StrongFocus);
}

FloatSpinBox::~FloatSpinBox()
{
}
