

#include "qxml.h"

using namespace QSAS;

extern DvList Wlist;

void write_WLtoXML(std::ofstream &ofp){
    
    DvClearXML(); // start with empty XML object list

	Wlist.toXML(ofp, DvString("WORKING_LIST") );
    
    DvClearXML(); // stop objects hanging around because they have var pointer on XML list

}


QDomElement createTextXMLNode(QDomDocument& doc, const QString& parentName, const QString& s)
{
    QDomElement res=doc.createElement(parentName);
    res.appendChild(doc.createTextNode(s));
    return res;
}

QDomElement createTextXMLNode(QDomDocument& doc, const QString& parentName, const std::string& s)
{
    QDomElement res=doc.createElement(parentName);
    res.appendChild(doc.createTextNode(QString::fromStdString(s)));
    return res;
}

QDomElement createTextXMLNode(QDomDocument& doc, const QString& parentName, const char* s)
{
    QDomElement res=doc.createElement(parentName);
    
    res.appendChild(doc.createTextNode(QString(s)));
    return res;
}

QDomElement createTextXMLNode(QDomDocument& doc, const QString& parentName, const double d)
{
    QDomElement res=doc.createElement(parentName);
    res.appendChild(doc.createTextNode(QString::number(d)));
    return res;
}

QDomElement createTextXMLNode(QDomDocument& doc, const QString& parentName, const int i)
{
    QDomElement res=doc.createElement(parentName);
    res.appendChild(doc.createTextNode(QString::number(i)));
    return res;
}

QDomElement createTextXMLNode(QDomDocument& doc, const QString& parentName, const bool b)
{
    QDomElement res=doc.createElement(parentName);
    res.appendChild(doc.createTextNode(QString::number((int)b)));
    return res;
}

bool getXMLNodeText(QDomElement& el, const QString& tag, QString& val)
{
    QDomElement subEl=el.firstChildElement(tag);
    if(!subEl.isNull())
    {
        val=subEl.firstChild().nodeValue();
        return true;
    }
    return false;
}



